#include "HelloWorldScene.h"
#include "another.h"

USING_NS_CC;

Scene* HelloWorld::createScene()
{
    // 'scene' is an autorelease object
	auto scene = Scene::createWithPhysics();
	//scene->getPhysicsWorld()->setGravity(Vec2::ZERO);
	scene->getPhysicsWorld()->setDebugDrawMask(PhysicsWorld::DEBUGDRAW_ALL);
    
    // 'layer' is an autorelease object
    auto layer = HelloWorld::create();

    // add layer as a child to scene
    scene->addChild(layer);

    // return the scene
    return scene;
}

// on "init" you need to initialize your instance
bool HelloWorld::init()
{
    //////////////////////////////
    // 1. super init first
    if ( !Layer::init() )
    {
        return false;
    }
    
    Size visibleSize = Director::getInstance()->getVisibleSize();
    Vec2 origin = Director::getInstance()->getVisibleOrigin();

    /////////////////////////////
    // 2. add a menu item with "X" image, which is clicked to quit the program
    //    you may modify it.

    // add a "close" icon to exit the progress. it's an autorelease object
    auto closeItem = MenuItemImage::create(
                                           "CloseNormal.png",
                                           "CloseSelected.png",
                                           CC_CALLBACK_1(HelloWorld::menuCloseCallback, this));
    
	closeItem->setPosition(Vec2(origin.x + visibleSize.width/2 - closeItem->getContentSize().width/2 ,
                                origin.y + visibleSize.height/2 - closeItem->getContentSize().height/2));

    // create menu, it's an autorelease object
    auto menu = Menu::create(closeItem, NULL);
    menu->setPosition(Vec2::ZERO);
    this->addChild(menu, 1);

    /////////////////////////////
    // 3. add your codes below...

	auto node = Node::create();
	//auto pb = PhysicsBody::createEdgeBox(visibleSize);
	auto pb = PhysicsBody::createEdgeSegment(origin, visibleSize);

	node->setPhysicsBody(pb);
	node->setPosition(visibleSize.width / 2, visibleSize.height / 2);
	this->addChild(node);
	

    // add a label shows "Hello World"
    // create and initialize a label
    
    auto label = Label::createWithTTF("Hello World", "fonts/Marker Felt.ttf", 24);
    
    // position the label on the center of the screen
    label->setPosition(Vec2(origin.x + visibleSize.width/2,
                            origin.y + visibleSize.height - label->getContentSize().height));

    // add the label as a child to this layer
    this->addChild(label, 1);

    // add "HelloWorld" splash screen"
    auto sprite = Sprite::create("HelloWorld.png");

    // position the sprite on the center of the screen
    sprite->setPosition(Vec2(visibleSize.width/2 + origin.x, visibleSize.height/2 + origin.y));

    // add the sprite as a child to this layer
    this->addChild(sprite, 0);

	auto lis = EventListenerTouchOneByOne::create();
	lis->onTouchBegan = [this](Touch* t, Event* e) {
		auto sp = Sprite::create("CloseNormal.png");
		auto body = PhysicsBody::createCircle(sp->getContentSize().width / 2);
		sp->setPhysicsBody(body);
		sp->setPosition(t->getLocation());
		this->addChild(sp);
		return true;
	};

	_eventDispatcher->addEventListenerWithSceneGraphPriority(lis, this);
    
    return true;
}


void HelloWorld::menuCloseCallback(Ref* pSender)
{
	auto s = AnotherScene::createScene();
	Director::getInstance()->replaceScene(TransitionFlipX::create(1.5f,s));
	//Director::getInstance()->replaceScene(s);
}
