#include "another.h"
#include "HelloWorldScene.h"

Scene* AnotherScene::createScene()
{
	auto s = Scene::createWithPhysics();
	s->getPhysicsWorld()->setDebugDrawMask(PhysicsWorld::DEBUGDRAW_ALL);

	auto l = AnotherScene::create();
	s->addChild(l);

	return s;
}

bool AnotherScene::init()
{
	if (!Layer::init())
		return false;

	Size visibleSize = Director::getInstance()->getVisibleSize();
	Vec2 origin = Director::getInstance()->getVisibleOrigin();

	/////////////////////////////
	// 2. add a menu item with "X" image, which is clicked to quit the program
	//    you may modify it.

	// add a "close" icon to exit the progress. it's an autorelease object
	auto closeItem = MenuItemImage::create(
		"CloseNormal.png",
		"CloseSelected.png",
		CC_CALLBACK_1(AnotherScene::menuCloseCallback, this));

	closeItem->setPosition(Vec2(origin.x + visibleSize.width / 2 - closeItem->getContentSize().width / 2,
		origin.y + visibleSize.height / 2 - closeItem->getContentSize().height / 2));

	// create menu, it's an autorelease object
	auto menu = Menu::create(closeItem, NULL);
	menu->setPosition(Vec2::ZERO);
	this->addChild(menu, 1);

	/////////////////////////////
	// 3. add your codes below...

	auto node = Node::create();
	//auto pb = PhysicsBody::createEdgeBox(visibleSize);
	auto pb = PhysicsBody::createEdgeSegment(origin, visibleSize);

	node->setPhysicsBody(pb);
	node->setPosition(visibleSize.width / 2, visibleSize.height / 2);
	this->addChild(node);


	auto lis = EventListenerTouchOneByOne::create();
	lis->onTouchBegan = [this](Touch* t, Event* e) {
		auto sp = Sprite::create("CloseNormal.png");
		auto body = PhysicsBody::createCircle(sp->getContentSize().width / 2);
		sp->setPhysicsBody(body);
		sp->setPosition(t->getLocation());
		this->addChild(sp);
		return true;
	};

	_eventDispatcher->addEventListenerWithSceneGraphPriority(lis, this);

	return true;
}

void AnotherScene::menuCloseCallback(Ref* pSender)
{
	auto s = HelloWorld::createScene();
	Director::getInstance()->replaceScene(TransitionFlipX::create(1.5f, s));
	//Director::getInstance()->replaceScene(TransitionFlipX::create(1.5f, s));
}